/******************************************************************/
/*                                                                */
/*              Plot the impulse response functions               */
/*                                                                */
/*                        Frank Schorfheide                       */
/*                                                                */
/******************************************************************/

/* filename: irfplot.g
** created:  09/27/01
*/
new;
library pgraph;
cls;

#include c:\projects\active\learnpol\gauss2\pathspec.g
#include c:\projects\active\learnpol\gauss2\lpspec.g

nirf  = 20;                /* number of impulse responses */
ti    = seqa(1,1,nirf);
mhrun  = "2";


/* Read Posterior Simulation Summary Files
*/
subTstr = "1";

lmodel = "m1";

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m      = readr(fhdraw,1);
irf_m11     = reshape(irf_m,5,nirf)';

closeall fhdraw;

lmodel = "m3";

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m   = readr(fhdraw,1);
irf_m21  = reshape(irf_m,5,nirf)';

closeall fhdraw;

lmodel = "m4";

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m   = readr(fhdraw,1);
irf_m31  = reshape(irf_m,5,nirf)';

closeall fhdraw;

/* Experiment 2
*/

subTstr = "2";

lmodel = "m1";

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m      = readr(fhdraw,1);
irf_m12     = reshape(irf_m,5,nirf)';

closeall fhdraw;

lmodel = "m3";

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m   = readr(fhdraw,1);
irf_m22  = reshape(irf_m,5,nirf)';

closeall fhdraw;

lmodel = "m4";

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m   = readr(fhdraw,1);
irf_m32  = reshape(irf_m,5,nirf)';

closeall fhdraw;


titlestr = "Output Growth / Exp 1" $| "Output Growth / Exp 2" $|
           "Inflation / Exp 1" $| "Inflation / Exp 2" $|
           "Nom Interest / Exp 1" $| "Nom Interest / Exp 2" $|
           "Composite Shock / Exp 1" $| "Composite Shock / Exp 2" $|
           "Prob (High Infl) / Exp 1" $| "Prob (High Infl) / Exp 2";

   
    graphset;
    begwind;
    margin(0,0,0.2,0.2);
    window(5,2,0);
    fonts("microb");
    _ptitlht = 0.5;
    _paxht = 0.5;
    _pnumht = 0.4;
    _pcolor =2 ;
    _pcolor = { 2 1 4 };
    _pltype = {6 1 2};
    _protate = 0; 
    _plctrl = 0;
    _plwidth = 5.5;
    _psymsiz = 5;
    _plegstr = "Full Information\000Learning\000No Learning";
    _plegctl = {2 6 3.5 1.5};   
    
       y_ind = 1;
       do until y_ind > 5;
       /* iterate over endogenous variables */

          /*
          if sh_ind == 4;
             ytics(0,0.5,0.1,1);
          endif;
          */

          title(titlestr[2*(y_ind-1)+1]);
          xy(ti, irf_m11[.,y_ind]~irf_m21[.,y_ind]~irf_m31[.,y_ind] );
          nextwind;
          _plegctl = { };   

          title(titlestr[2*y_ind]);
          xy(ti, irf_m12[.,y_ind]~irf_m22[.,y_ind]~irf_m32[.,y_ind] );
          nextwind;
                 
          y_ind = y_ind+1;
       endo;
           
    endwind;

