/******************************************************************/
/*                                                                */
/*              Plot the impulse response functions               */
/*                                                                */
/*                        Frank Schorfheide                       */
/*                                                                */
/******************************************************************/

/* filename: irfplot.g
** created:  09/27/01
*/
new;
library pgraph;
cls;

#include c:\projects\active\learnpol\gauss2\pathspec.g
#include c:\projects\active\learnpol\gauss2\lpspec.g

nirf  = 20;                /* number of impulse responses */
ti    = seqa(1,1,nirf);
mhrun  = "2";


/* Read Posterior Simulation Summary Files
*/
lmodel = "m3";
subTstr = "1";

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m      = readr(fhdraw,1);
irf_m1     = reshape(irf_m,5,nirf)';

closeall fhdraw;

subTstr = "2";

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m      = readr(fhdraw,1);
irf_m2     = reshape(irf_m,5,nirf)';

closeall fhdraw;

subTstr = "5";

lpath  = resupath $+ "\\mhrun1" ;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m   = readr(fhdraw,1);
irf_m3  = reshape(irf_m,5,nirf)';

closeall fhdraw;

subTstr = "6";

lpath  = resupath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "irs";

open fhdraw = ^ldraw for read;

irf_m   = readr(fhdraw,1);
irf_m4  = reshape(irf_m,5,nirf)';

closeall fhdraw;

titlestr = "Output Growth" $|
           "Inflation" $|
           "Nom Interest" $|
           " " $|
           "Prob (High Infl)";
   
    graphset;
    begwind;
    margin(0,0,0.2,0.2);
    window(4,2,0);
    fonts("microb");
    _ptitlht = 0.5;
    _paxht = 0.5;
    _pnumht = 0.45;
    _pcolor = 2 ;
    _pcolor = { 2 1 4 };
    _pltype = {6 1 2};
    _protate = 0; 
    _plctrl = 0;
    _plwidth = 5.5;
    _psymsiz = 5;
    _plegstr = "Heterosked. Shock\000Homosked. Shock";
    _plegctl = {2 6 3.5 1.5};   
    
       y_ind = 1;
       do until y_ind > 5;
       /* iterate over endogenous variables */

          title(titlestr[y_ind] $+ " / Exp 1");
          xy(ti, irf_m1[.,y_ind]~irf_m3[.,y_ind] ); 
          nextwind;
          _plegctl = { };   
                 
          title(titlestr[y_ind] $+ " / Exp 2");
          xy(ti, irf_m2[.,y_ind]~irf_m4[.,y_ind] ); 
          nextwind;

          if y_ind == 3;
             y_ind = y_ind+2;
          else;
             y_ind = y_ind+1;
          endif;

       endo;
           
    endwind;

