/*******************************************************/
/*                                                     */
/* Computing Regime conditional long-run means         */
/*                                                     */
/*******************************************************/

/* filename:    lpstst.g
** description: The program converts the DSGE parameters
**              into long-run regime conditional means
** created:     
*/

new;
closeall;
library pgraph, user;
cls;

/* Global defaults 
*/
  __output = 0;

#include c:\projects\active\learnpol\gauss2\pathspec.g;
#include c:\projects\active\learnpol\gauss2\lpspec.g;


/* Open files with Parameter Draws
*/
mhrun  = "1";

lpath  = parapath $+ "\\mhrun" $+ mhrun;
opath  = resupath $+ "\\mhrun" $+ mhrun;

ltheta  = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "pt";
lphi    = lpath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "pp";

open fhtheta = ^ltheta for read;
open fhphi   = ^lphi for read;

/* Define some Constants
*/
nblock  = 100;    /* block size */
nuse    = 1;    /* use every nuse observation */

/* Initialize Output files
*/
ostst = opath $+ "\\" $+ lmodel $+ lprior $+ dataselstr $+ subTstr $+ "rs";
create fhstst = ^ostst with YSTST, 12, 8;
       
/* Initialization
*/ 
eofloop = 0;
loopct  = 1;

do until eofloop; 

   /* Read blocks of size nblock
   */
   thetasim = readr( fhtheta, nblock );
   phisim   = readr( fhphi, nblock);
   
   nread = rows(thetasim);

   indseq = seqa(1,1,nread);
   indseq = indseq % nuse;
   indseq = indseq .NE 0;
 
   thetasim = delif(thetasim,indseq);
   phisim   = delif(phisim,indseq);
   
   nread = rows(thetasim);

   yststsim = zeros(nread,12);
   
   j = 1;
   do until j > nread;
   
      /* For each element of the block, compute the desired statistic
      */
      
      theta = thetasim[j,.]';
      phi   = phisim[j,.]';
     
      ystst = lpstst(theta,phi,1,mspec)' ~ lpstst(theta,phi,2,mspec)';
       
      yststsim[j,.] = ystst;
      
      j = j+1;
      
   endo;

   /* Write Output
   */
   wr = writer(fhstst,yststsim);

   locate 1,1;
   "Block" loopct;
   "Draws Processed:" nread;   

   loopct = loopct + 1;
   eofloop = eof(fhtheta);

endo;

closeall fhtheta, fhphi, fhstst;
      
#include c:\projects\active\learnpol\gauss2\lpmod.src;
#include c:\projects\active\learnpol\gauss2\lpstst.src;
