/* filename: lptest.g
** created:  10/18/01
** Modifications:
**
*/
new;
cls;
library pgraph, user;
dlibrary -a PszTgSen,PsdTgSen;
__output = 0;
   
/* Define model parameters
*/
  
   gam     = 0.5;
   pila    = 3;
   pida    = 3;
   rsta    = 2;

   tau     = 1/2;
   kap     = 0.4;
   psi     = 1.5;

   rhog    = 0.9;
   rhoz    = 0.3;
   rhor    = 0.7;
   
   sigg    = 1;
   sigz    = 1;
   sigrla  = 1;
   sigrha  = 1;

   para  = gam  | pila | pida | rsta | tau | kap | psi | rhog | rhoz | rhor |
           sigg | sigz | sigrla | sigrha;

   phi = 0.95 | 0.95 ;

   prob0  = (1-phi[2])/(2-phi[1]-phi[2]) | 
            (1-phi[1])/(2-phi[1]-phi[2]) ;


format /mb1 /rds 12,6;

{T1,TC,T0,EXPeffect_f,EXPeffect_m,RC} = dsgesolv(para,phi);

/* Impulse response functions
*/
nirf   = 20;
ti     = seqa(1,1,nirf);

titlestr = "Experiment 1"   $|
           "Experiment 2"   $|
           "Experiment 3";

ystr     = "Output" $|
           "Inflation" $|
           "Nom Interest" $|
           "State" ;

graphset;
fonts("microb");
_ptitlht = 0.4;
_paxht = 0.4;
_pnumht = 0.4;
_pltype = {6 1 2}; 
_plegstr = "Full Info - No Shift\000Full Info - Shift\000Limited Info"; 
_plegctl = {2 4 4 4};
_plwidth = 3.5;

begwind;
window(2,2,0);

/* Experiment 1: transitory increase in interest rate
*/
RT = 1*ones(5,1);

ST = 0 ~ 0;
yT1 = lpirf(para,phi,RT,ST,nirf,5000,1);

ST = ones(5,1) ~ zeros(5,1);
yT2 = lpirf(para,phi,RT,ST,nirf,5000,1);

yT3 = lpirf(para,phi,RT,ST,nirf,5000,3);

/*
scale(ti,yT1~yT2~yT3);
*/

varind = 1;
do until varind > 4;

   yT1plot = yT1[.,varind];
   yT2plot = yT2[.,varind];
   yT3plot = yT3[.,varind];

   yTirf = yT1plot~yT2plot~yT3plot;
   title(titlestr[1]);
   ylabel(ystr[varind]);
   xlabel("Period");
   xy(ti,yTirf);
   nextwind;
      
   varind = varind+1;

endo;

endwind;

end;


#include c:\projects\active\learnpol\gauss2\lpmod.src
#include c:\projects\active\learnpol\gauss2\lpirf.src
