/* filename:    paratab1.g
** description: generates a LaTeX Table  
*/

new;
closeall;
library user, pgraph;
cls;
outwidth 128;

/******************************************************************
**         Load Parameter Draws from MH Output
*/
#include c:\projects\active\learnpol\gauss2\pathspec.g;
#include c:\projects\active\learnpol\gauss2\lpspec.g;

/* Specify input files - you have to edit the inputfile_str
** to read the desired estimates
** filename: lmodel + lprior + dataselstr + subTstr + pas
*/
inputfile_str = "c:\\projects\\active\\learnpol\\gauss1\\para\\mhrun2\\m1101pas"
             $| "c:\\projects\\active\\learnpol\\gauss2\\para\\mhrun2\\m1101pts"
             $| "c:\\projects\\active\\learnpol\\gauss2\\para\\mhrun2\\m3101pts"
             $| "c:\\projects\\active\\learnpol\\gauss2\\para\\mhrun2\\m1101pps"
             $| "c:\\projects\\active\\learnpol\\gauss2\\para\\mhrun2\\m3101pps";


/* Specify row names for table
*/
row_name =  "$\\gamma$         "
         $| "$\\pi^*_L$        "
         $| "$\\pi^*_H - \\pi^*_L$ "         
         $| "$r$               "
         $| "$\\tau$           "
         $| "$\\kappa$         "
         $| "$\\psi$           "
         $| "$\\rho_g$         "
         $| "$\\rho_z$         "         
         $| "$\\rho_R$         "
         $| "$\\sigma_g$       "
         $| "$\\sigma_z$       "
         $| "$\\sigma_{R,L}$   "
         $| "$\\sigma_{R,H}$   " 
         $| "$\\phi_1$         "
         $| "$\\phi_2$         ";

             
inputfile_n = rows(inputfile_str);

post_mean = zeros(npara,inputfile_n);
post_ci   = zeros(npara,inputfile_n*2);

nparaall  = npara - 4 | nparat | nparat | nparap | nparap; 

/* read the input files
*/
inputfile_ind = 1;

do until inputfile_ind > inputfile_n;

   lparas = inputfile_str[inputfile_ind];
   open fhparas = ^lparas for read;
   
   post_mean[1:nparaall[inputfile_ind],inputfile_ind] = readr(fhparas,1)';
   drawrow = seekr(fhparas,nparaall[inputfile_ind]+3);
   post_ci[1:nparaall[inputfile_ind],2*(inputfile_ind-1)+1:2*inputfile_ind] = readr(fhparas,2)';

   inputfile_ind = inputfile_ind+1;
   
   closeall fhparas;
   
endo;

/* Shift parameters for fixed coefficient model
*/
post_mean[.,1] = post_mean[1:2,1] | 0 | post_mean[3:npara-4,1] | zeros(3,1) ;
post_ci[.,1:2] = post_ci[1:2,1:2] | (0~0) | post_ci[3:npara-4,1:2] |  zeros(3,2);  

post_mean[npara-1:npara,2:3] = post_mean[1:2,4:5];
post_ci[npara-1:npara,3:6]   = post_ci[1:2,7:10];

post_mean = post_mean[.,1:3];
post_ci   = post_ci[.,1:6];

inputfile_n = inputfile_n - 2;

/* Create table
*/
para_ind = 1;
do until para_ind > npara;

   tablerow = row_name[para_ind];

   inputfile_ind = 1;
   do until inputfile_ind > inputfile_n;
      
      tablerow = tablerow $+ " & " $+ ftos(post_mean[para_ind,inputfile_ind],"%*.*lf",5,2)
                 $+ " & [" $+ ftos(post_ci[para_ind,2*(inputfile_ind-1)+1],"%*.*lf",5,2)
                 $+ ", "  $+ ftos(post_ci[para_ind,2*(inputfile_ind)],"%*.*lf",5,2) $+ "]";
      inputfile_ind = inputfile_ind+1;
      
   endo;
   tablerow  = tablerow  $+ "\\\\";
   
   $tablerow;
   
   para_ind = para_ind+1;

endo;
